/********************************************************************************
*                                                                               *
*                      F X   M O V I E   M A N A G E R                          *
*                                                                               *
*********************************************************************************
* Copyright(C) 2008,2012 by Luigi Ziviani <ziviani_luigi@yahoo.it>.             *
* All Rights Reserved.                            version 5.6                   *
*********************************************************************************
* Id: playerdialog.cpp,                           2008/01/01                    *
*********************************************************************************
* This file is part of FXMOVIEMANAGER                                           *
*                                                                               *
* FXMOVIEMANAGER is free software; you can redistribute it and/or modify        *
* it under the terms of the GNU General Public License as published by          *
* the Free Software Foundation; either version 3 of the License, or             *
* (at your option) any later version.                                           *
*                                                                               *
* FXMOVIEMANAGER is distributed in the hope that it will be useful,             *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 *
* GNU General Public License for more details.                                  *
*                                                                               *
* You should have received a copy of the GNU General Public License             *
* along with this program; if not, write to the Free Software                   *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA     * 
********************************************************************************/

#include "config.h"
#include <xincs.h>
#include <fx.h>
#include "icons.h"
#include "PlayerDialog.h"

// Message Map for the Scribble Window class
FXDEFMAP(PlayerDialog) PlayerDialogMap[]={

  //________Message_Type_____________________ID____________Message_Handler_______
  FXMAPFUNC(SEL_COMMAND,	   PlayerDialog::ID_ACCEPT,  PlayerDialog::onCmdAccept),
  FXMAPFUNC(SEL_COMMAND,	   PlayerDialog::ID_CANCEL,  PlayerDialog::onCmdCancel),
  };


FXIMPLEMENT(PlayerDialog,FXDialogBox,PlayerDialogMap,ARRAYNUMBER(PlayerDialogMap))

// the internal SDL player
#ifdef HAVE_SDL_SDL_H
extern "C" int loadPlayerFile(char[1024], int64_t, int64_t, int, int, int, int, int, int, int, float);
#endif

char plist[1024];
int px, py, pl, pf, pd, pa, pv;
int64_t pts, ptd;
float pta;

// Create properties dialog
PlayerDialog::PlayerDialog(FXWindow *own):FXDialogBox(own,"Start Player",DECOR_TITLE|DECOR_BORDER|DECOR_RESIZE,0,0,0,0, 4,4,4,4, 4,4){

  cancelicon=new FXGIFIcon(getApp(),m_cancel);
  accepticon=new FXGIFIcon(getApp(),m_accept);

  // buttons
  buttonsframe=new FXHorizontalFrame(this,LAYOUT_SIDE_BOTTOM|LAYOUT_FILL_X|PACK_UNIFORM_WIDTH,0,0,0,0, 0,0,0,0);
  new FXButton(buttonsframe,tr("&CANCEL"),cancelicon,this,ID_CANCEL,BUTTON_DEFAULT|BUTTON_NORMAL|LAYOUT_CENTER_X|LAYOUT_CENTER_Y,0,0,0,0,20,20);
  new FXButton(buttonsframe,tr(" &PLAY "),accepticon,this,ID_ACCEPT,BUTTON_INITIAL|BUTTON_DEFAULT|BUTTON_NORMAL|LAYOUT_CENTER_X|LAYOUT_CENTER_Y);

  }


void PlayerDialog::setCmd(char list[1024], int64_t ts, int64_t td, int x, int y, int l, int f, int d, int a, int v, float ta){ 
  px = x;
  py = y;
  pts = ts;
  ptd = td;
  pl = l;
  pf = f;
  pd = d;
  pa = a;
  pv = v;
  pta = ta;
  stpncpy(plist, list, sizeof(plist));

}

// Close dialog with an accept
long PlayerDialog::onCmdAccept(FXObject*,FXSelector,void*){
  getApp()->stopModal(this,true);
  PlayerDialog::hide();
  loadPlayerFile(plist, pts, ptd, px, py, pl, pf, pd, pa, pv, pta); 

  return 1;
  }


// Close dialog with a cancel
long PlayerDialog::onCmdCancel(FXObject*,FXSelector,void*){
  getApp()->stopModal(this,false);
  PlayerDialog::hide();

  return 1;
  }


// Destroy
PlayerDialog::~PlayerDialog(){

  delete cancelicon;
  delete accepticon;

  }



